
#include <GL/glui.h>
#include "tentacle.h"
#include <iostream>

int main_window;
GLUI* sub_window;

Tentacle *root;
Tentacle *current;

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);
	glLoadIdentity();

	root->glRender();

	glutSwapBuffers();
}

void reshape(int x, int y)
{
	GLUI_Master.auto_set_viewport();
	glutPostRedisplay();
}

void glInit()
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glOrtho(-100, 100, -100, 100, -1, 1);

	glMatrixMode(GL_MODELVIEW);
}

void updateCurrent(Tentacle *latest)
{
	if(latest != current)
	{
		sub_window->close();
		sub_window = GLUI_Master.create_glui_subwindow( main_window
														, GLUI_SUBWINDOW_LEFT
				);
		sub_window->set_main_gfx_window(main_window);

		latest->setupUI(sub_window);
		latest->setSelected(true);

		current->setSelected(false);
		current = latest;
	}
}

void special(int key, int x, int y)
{
	Tentacle *t;

	switch(key)
	{
		case GLUT_KEY_UP:
			t = current->getParent();
			break;

		case GLUT_KEY_DOWN:
			t = current->firstChild();
			break;

		case GLUT_KEY_RIGHT:
		case GLUT_KEY_LEFT:
			t = current->nextSibling();
			break;

		default:
			;
	}

	if(t != NULL)
	{
		updateCurrent(t);
		glutPostRedisplay();
	}
}


Tentacle *buildOctopus()
{
	Tentacle *body = new Tentacle(-25, -25, 50, 50, 0, NULL);

	Tentacle *tr = new Tentacle(5, 5, 30, 15, -120, body);
	Tentacle *tr2 = new Tentacle(28, 7.5, 25, 15, 45, tr);
	Tentacle *tr3 = new Tentacle(24, 7.5, 20, 15, 3, tr2);
	Tentacle *tr21 = new Tentacle(28, 7.5, 25, 15, -45, tr);
	Tentacle *tr31 = new Tentacle(24, 7.5, 20, 15, 3, tr21);

	Tentacle *tl = new Tentacle(5, 45, 30, 15, 120, body);
	Tentacle *tl2 = new Tentacle(28, 7.5, 25, 15, 3, tl);
	Tentacle *tl3 = new Tentacle(24, 7.5, 20, 15, 3, tl2);

	Tentacle *br = new Tentacle(45, 5, 30, 15, -60, body);
	Tentacle *br2 = new Tentacle(28, 7.5, 25, 15, 3, br);
	Tentacle *br3 = new Tentacle(24, 7.5, 20, 15, 3, br2);

	Tentacle *bl = new Tentacle(45, 45, 30, 15, 60, body);
	Tentacle *bl2 = new Tentacle(28, 7.5, 25, 15, 3, bl);
	Tentacle *bl3 = new Tentacle(24, 7.5, 20, 15, 3, bl2);


	return body;
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);

	glutInitWindowPosition(200, 200);
	glutInitWindowSize(800, 600);

	main_window = glutCreateWindow("GLUI App");

	sub_window = GLUI_Master.create_glui_subwindow( main_window
													, GLUI_SUBWINDOW_LEFT
													);
	sub_window->set_main_gfx_window(main_window);

	root = buildOctopus();

	root->setupUI(sub_window);
	root->setSelected(true);
	current = root;

	glutDisplayFunc(display);

	GLUI_Master.set_glutReshapeFunc(reshape);
	GLUI_Master.set_glutSpecialFunc(special);
	GLUI_Master.set_glutIdleFunc(NULL);

	glInit();

	glutMainLoop();

	return 0;
}
